
#ifndef __ATOFONT_CORE_H
#define __ATOFONT_CORE_H

#define ATOFONT_TYPE_FIXED        0
#define ATOFONT_TYPE_PROPORTIONAL 1

#define ATOFONT_CENTERED 1

struct atocharacter {
  float x, y;
  float width;
  float left_margin;
};

struct atofont {
  unsigned char *texture_data;
  int texture_dx;
  int texture_dy;
  int texture_type;
  int character_dx;
  int character_dy;
  float character_fixed_width;
  float character_fixed_height;
  unsigned char type;
  float scale_x;
  float scale_y;
  float spacing;
  float vertices[4*2];
  struct atocharacter characters[256];
};

#ifdef __cplusplus
extern "C" {
#endif

/* private functions */
float _atofont_get_string_width(struct atofont *font, unsigned char *s);
int   _atofont_billboard_spherical_cheat_apply(float x, float y, float z);

/* public functions */
int atofont_free(struct atofont *font);
int atofont_create(struct atofont **font, unsigned char *t, int type, int tx, int ty, int cx, int cy);
int atofont_set_spacing(struct atofont *font, float spacing);
int atofont_set_scaling(struct atofont *font, float scale_x, float scale_y);
int atofont_set_type(struct atofont *font, int type);

#ifdef __cplusplus
}
#endif

#endif
